; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; LOAD SOUNDS
If soundEnabled
	sndClick = LoadSound("sounds\click.mp3")
	sndDeath = LoadSound("sounds\explode.mp3")
	sndWallBust = LoadSound("sounds\crumble.mp3")
	sndJumpAct = LoadSound("sounds\jumpact.mp3")
	sndTurnAct = LoadSound("sounds\turnact.mp3")
	sndJump = LoadSound("sounds\jump.mp3")
	sndBox = LoadSound("sounds\box.mp3")
	sndCollision = LoadSound("sounds\collision.mp3")
	sndPoints = LoadSound("sounds\points.mp3")
	sndShrunk = LoadSound("sounds\shrunk.mp3")
	sndWarp = LoadSound("sounds\warp.mp3")
	sndTurn = LoadSound("sounds\turn.mp3")
	sndRad = LoadSound("sounds\rad.mp3")
	sndWin = LoadSound("sounds\win.mp3")
	sndSpawn = LoadSound("sounds\spawn.mp3")
	sndYeah = LoadSound("sounds\yeah.mp3")
	SoundVolume sndClick, soundVol
	SoundVolume sndDeath, soundVol
	SoundVolume sndWallBust, soundVol
	SoundVolume sndJumpAct, soundVol
	SoundVolume sndTurnAct, soundVol
	SoundVolume sndJump, soundVol
	SoundVolume sndBox, soundVol
	SoundVolume sndCollision, soundVol
	SoundVolume sndPoints, soundVol
	SoundVolume sndShrunk, soundVol
	SoundVolume sndWarp, soundVol
	SoundVolume sndTurn, soundVol
	SoundVolume sndRad, soundVol
	SoundVolume sndWin, soundVol
	SoundVolume sndSpawn, soundVol
	SoundVolume sndYeah, soundVol
End If

; SET ARRAYS
Dim objNibbler(1000)
Dim HSScore(10)
Dim HSLevel(10)
Dim HSDiff(10)
Dim HSName$(10)
Dim objOdo(7)
Dim objSideL(7)
Dim objSideR(7)
Dim target(7)
Dim current(7)
Dim tex(2)
Dim emtPuff(12)
Global Puffs

; LOAD TEXTURES
texNibble = LoadTexture("images\nibble.bmp")
ScaleTexture texNibble, 0.7, 0.7
texNuke = LoadTexture("images\nuke.bmp")
ScaleTexture texNuke, 0.0001, 0.0001
texDigits = LoadTexture("images\lcdgts_a.jpg")
texSides = LoadTexture("images\sides.jpg")
texBox = LoadTexture("images\box.jpg")
texSpark = LoadTexture("images\spark.tga", 2)
texWhite = LoadTexture("images\white.tga", 2)
texGreen = LoadTexture("images\green.tga", 2)
texYellow = LoadTexture("images\yellow.tga", 2)
texBlue = LoadTexture("images\blue.tga", 2)

; Create a single "squarish" triangle
Global objTri = CreateMesh()
sfcTri = CreateSurface(objTri)
v0 = AddVertex(sfcTri, -5, -5, 0, 0,   0) 
v1 = AddVertex(sfcTri, 5, -5, 0, 1,   0) 
v2 = AddVertex(sfcTri, 0,   5, 0, 0.5, 1)
AddTriangle(sfcTri,v0,v1,v2)
HideEntity objTri

; LOAD ODOMETERS COMPLEX/SIMPLE SCORE
camOdo = CreateCamera()
PositionEntity camOdo, 152, 200, -305 + 10000
CameraClsColor camOdo, 77, 155, 0

If complexscore Then
	For count = 0 To 6
		current(count) = 205
		target(count) = 205
		objOdo(count) = CreateCylinder(odoDetail)
		ScaleEntity objOdo(count), 50, 20, 50
		EntityTexture objOdo(count), texDigits
		PositionEntity objOdo(count), 50  * count, 200, 0 + 10000
		RotateEntity objOdo(count), current(count), 0, 90
		objSideL(count) = CreateCylinder(odoDetail)
		ScaleEntity objSideL(count), 55, 1, 55
		EntityTexture objSideL(count), texSides
		PositionEntity objSideL(count), -20 + 50  * count, 200, 0 + 10000
		RotateEntity objSideL(count), current(count), 0, 90
		objSideR(count) = CreateCylinder(odoDetail)
		ScaleEntity objSideR(count), 55, 1, 55
		EntityTexture objSideR(count), texSides
		PositionEntity objSideR(count), 20 + 50  * count, 200, 0 + 10000
		RotateEntity objSideR(count), current(count), 0, 90
	Next

	objPipe = CreateCylinder(odoDetail)
	ScaleEntity objPipe, 10, 250, 10
	EntityColor objPipe, 120, 120, 120
	PositionEntity objPipe, 150, 200, -20 + 10000
	RotateEntity objPipe, 0, 0, 90
	
	RotateTexture texDigits, 270

End If

CameraViewport camOdo, 140, 370, 199, 59
CameraZoom camOdo, 1.45

; DEFAULT VALUES
name$ = "Enter your name"
difficulty = 2
startinglives = 6
maxDiff = 3
message$ = "Welcome to Nuclear Nibble 3D v" + VersionNumber