; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; SCREEN SETTINGS, NO TOUCH
scrWidth = 640
scrHeight = 480
scrDepth = 16
frmRateLimit = 40
VersionNumber$ = "1.0.3"

; READ CONFIGURATION SETTINGS, USER SET
filCFG = ReadFile("nn3d.cfg")
	sphereDetail =  Int(ReadLine(filCFG))
	odoDetail =  Int(ReadLine(filCFG))
	displayfps = Int(ReadLine(filCFG))
	complexscore = Int(ReadLine(filCFG))
	complexlevel = Int(ReadLine(filCFG))
	masking = Int(ReadLine(filCFG))
	mirror = Int(ReadLine(filCFG))
	transparency = Int(ReadLine(filCFG))
	msgtrans = Int(ReadLine(filCFG))
	soundEnabled = Int(ReadLine(filCFG))
	soundVol# = Float(ReadLine(filCFG))
	musicEnabled = Int(ReadLine(filCFG))
	musicVol# = Float(ReadLine(filCFG))
	particlesEnabled = Int(ReadLine(filCFG))
	keyLeft = Int(ReadLine(filCFG))
	keyRight = Int(ReadLine(filCFG))
	keyJump = Int(ReadLine(filCFG))
	keySharpLeft = Int(ReadLine(filCFG))
	keySharpRight = Int(ReadLine(filCFG))
CloseFile(filCFG)

If sphereDetail < 0 Or sphereDetail > 8 Or odoDetail < 6 Or odoDetail > 12 Then
	RuntimeError "Error in configuration file."
End If
If displayfps < 0 Or displayfps > 1 Or complexscore < 0 Or complexscore > 1 Then
	RuntimeError "Error in configuration file."
End If
If complexlevel < 0 Or complexlevel > 1 Or masking < 0 Or masking > 1 Then
	RuntimeError "Error in configuration file."
End If
If mirror < 0 Or mirror > 1 Or transparency < 0 Or transparency > 1 Then
	RuntimeError "Error in configuration file."
End If
If msgtrans < 1 Or msgtrans > 320 Then
	RuntimeError "Error in configuration file."
End If
If sphereDetail = 0 Then
	mirror = False
	transparency = False
End If

; SETS SCREEN
Graphics3D scrWidth, scrHeight, scrDepth, 2
SetBuffer FrontBuffer()
frmRateTimer = CreateTimer(frmRateLimit)
HidePointer
lastfps = frmRateLimit
AppTitle "Nuclear Nibble 3D"

; INCLUDES
Include "ParticleWorks.bb"

; COLLISIONS
typHead = 1
typNibble = 2
typWalls = 3
Collisions typHead, typNibble, 1, 2
Collisions typHead, typWalls, 2, 2

; INTRO
Include "intro.bb"

; INITIALIZATION
Include "init.bb"

; GAME MENU
Include "menu.bb"

HidePointer

; GAME SETTING
Include "gamesetting.bb"

; LOAD LEVEL
Include "loadlevel.bb"

.Play

;START GAME

snakepos# = 5
ld# = .25
c = False
finished = False
DrawImage imgUI, 0, 0
boxtimer = MilliSecs()
boxcount = 0
Turn90Activated = MilliSecs() - 30000
JumpActivated = MilliSecs() - 30000
jumping = False
turning = False
ncount = 50
jump = 0
coll# = 0
nukeX = 0
nukeY = 0
boxX = 0
boxY = 0

Color 85, 85, 85
Text messagep + 1, 459, message, True, True
Color 255, 255, 200
Text messagep, 458, message, True, True

For i = 0 To 12
	PW_KillParticles(emtPuff(i))
	PW_KillEmitter(emtPuff(i))
Next
Puffs = 0

While Not finished

; FRAME RATE LIMITER
	WaitTimer(frmRateTimer)
	finished = c
; FADE IN MUSIC
	If mVol < musicVol And musicEnabled Then
		mVol = mVol + 0.01
		If mVol > musicVol Then
			mVol = musicVol
		End If
		ChannelVolume chnMusic, mVol
	End If

; APPLY CAMERA MOVEMENTS
	TranslateEntity camDefault, (EntityX(objCamTarget, True) - EntityX(camDefault)) / 3, (EntityY(objCamTarget, True) - EntityY(camDefault)) / 3, (EntityZ(objCamTarget, True) - EntityZ(camDefault)) / 3
	If EntityX(camDefault) > 23 Then
		PositionEntity camDefault, 23, EntityY(camDefault), EntityZ(camDefault)
	End If
	If EntityX(camDefault) < -23 Then
		PositionEntity camDefault, -23, EntityY(camDefault), EntityZ(camDefault)
	End If
	If EntityZ(camDefault) > 23 Then
		PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 23
	End If
	If EntityZ(camDefault) < -23 Then
		PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), -23
	End If
	If FPSView Then
		RotateEntity camDefault, 0, EntityYaw(objNibbler(0)) - 90, 0
	Else
		PointEntity camDefault, objNibbler(0)
	End If

; GENERATE A NEW BOX EVERY 30 SECONDS, IF NOT PRESENT. MAX 10 BOXES
	If (Not box) And (boxtimer < (MilliSecs() - 12000)) And (boxcount < 10) Then
		If soundEnabled Then PlaySound sndBox
		boxtimer = MilliSecs()
		SeedRnd MilliSecs()
		box = True
		boxcount = boxcount + 1
		objBox = CreateCube()
		lgtBox = CreateLight(2, objBox)
		LightColor lgtBox, 50, 0, 250
		LightRange lgtBox, 2
		EntityTexture objBox, texBox
		x = 1
		y = 1
		While walls(x, y) Or (nukeX = x And nukeY = y)
			x = Rand(2, 24)
			y = Rand(2, 24)
		Wend
		boxX = x
		boxY = y
		PositionEntity objBox, x * 2 - 26, 1.3, y * 2 - 26
		CreatePuff(objBox, camDefault, texBlue, texWhite, texSpark)
		ScaleEntity objBox, 0.75, 0.75, 0.75
	ElseIf box
		TurnEntity objBox, 0, -3, 0
; IF BOX IS WITHIN 1.5 RADIUS, GET IT
		dnx# = EntityX(objNibbler(0)) - EntityX(objBox)
		dnz# = EntityZ(objNibbler(0)) - EntityZ(objBox)
		dn# = Sqr(dnx# * dnx# + dnz# * dnz#)
		If dn# <= 1.5 Then
			CreatePuff(objNibbler(0), camDefault, texBlue, texWhite, texSpark)
			FreeEntity lgtBox
			FreeEntity objBox
			box = False
			SeedRnd MilliSecs()
			power = Rand(1, 110)
			boxtimer = MilliSecs()
			msgid = msgid + 1
			If power <= 12 Then
; JUMP
				If soundEnabled Then PlaySound sndJumpAct
				score = score + 200	* difficulty
				If jumping And (JumpActivated > (MilliSecs() - 30000)) Then
					JumpActivated = JumpActivated + 30000
					newmessage = "Jump activated for longer."
				Else
					JumpActivated = MilliSecs()
					newmessage = "Special ability: jump. Use space bar to jump."
				End If
				jumping = True
			ElseIf power <= 29 Then
; SHRINK
				If soundEnabled Then PlaySound sndShrunk
				power = Rand(20, 75)
				If length - power < 50 Then
					power = length - 50
				End If
				While length > 50 And power > 0
					FreeEntity objNibbler(length)
					length = length - 1
					power = power - 1
				Wend
				score = score + 100	* difficulty
				newmessage = "Shrunk worm!"
			ElseIf power <= 49 Then
; LENGTH
				If soundEnabled Then PlaySound sndRad
				score = score + 300	* difficulty
				newmessage = "Radiations! Worm lengthened."
				power = Rand(10, 50)
				For count = length + 1 To length + power
					px# = EntityX(objNibbler(count - 1))
					py# = EntityY(objNibbler(count - 1))
					pz# = EntityZ(objNibbler(count - 1))
					If sphereDetail > 1 Then
						objNibbler(count) = CreateSphere(sphereDetail)
					ElseIf sphereDetail = 1 Then
						objNibbler(count) = CreateCone(3)
					ElseIf sphereDetail = 0 Then
						objNibbler(count) = LoadSprite("nibbler.bmp", 4)
						SpriteViewMode objNibbler(count), 1
					End If
					If sphereDetail > 0 Then
						EntityTexture objNibbler(count), texNibble
					End If
					RotateEntity objNibbler(count), Rnd(0, 360), Rnd(0, 360), Rnd(0, 360)
					PositionEntity objNibbler(count), px#, py#, pz#
					EntityType objNibbler(count), typNibble
					EntityRadius objNibbler(count), 1
				Next
				length = length + power
	
			ElseIf power <= 51 Then
; LIFE
				If soundEnabled Then PlaySound sndYeah
				score = score + 500	* difficulty
				newmessage = "Bonus life!"
				lives = lives + 1
			ElseIf power <= 52 Then
; DEATH
				If soundEnabled Then PlaySound sndDeath
				score = score + 1000 * difficulty
				newmessage = "Instant death!"
				c = True
			ElseIf power <= 72 Then
; TURN 90
				If soundEnabled Then PlaySound(sndTurnAct)
				score = score + 400	* difficulty
				If turning And (Turn90Activated > (MilliSecs() - 30000)) Then
					Turn90Activated = Turn90Activated + 30000
					newmessage = "Sharp turns activated for longer."
				Else
					Turn90Activated = MilliSecs()
					newmessage = "Special ability: sharp turns. Use Z and X to turn."
				End If
				turning = True
			ElseIf power <= 75 Then
; NEXT LEVEL
				If level < 20 Then
					If soundEnabled Then PlaySound sndWarp
					score = score + 400	* difficulty
					newmessage = "Level warp! Welcome to level " + (level + 1) + "."
					level = level + 1
					collected = 0
					Gosub level
				Else
					If soundEnabled Then PlaySound sndPoints
					score = score + 10000
					newmessage = "10,000 bonus points!"
				End If
			ElseIf power <= 88 Then
; RANDOM BUST		
				power = Rand(4, 7)
				dest = 0
				While dest < power And wallcount > 96
					x = Rand(2, 24)
					y = Rand(2, 24)
					If walls(x, y) Then
						dest = dest  + 1
						wallcount = wallcount - 1
						FreeEntity objWalls(x, y)
						walls(x, y) = 0
					End If
				Wend
				If wallcount = 96 Then
					score = score + 150 * (5 - dest) * difficulty
				End If
				If dest > 0 Then
					If soundEnabled Then PlaySound sndWallBust
					score = score + 250	* difficulty
					newmessage = dest + " walls were busted!"
				Else
					If soundEnabled Then PlaySound sndPoints
					newmessage = "2,500 points bonus!"
					score = score + 2500
				End If
			ElseIf power <= 100 Then
; RANDOM SPAWN
				If soundEnabled Then PlaySound sndSpawn
				score = score + 750	* difficulty
				power = Rand(5, 10)
				newmessage = power + " new walls spawned!"
				spawn = 0
				While spawn < power
					x = Rand(2, 24)
					y = Rand(2, 24)
					If (walls(x, y) = 0) And (nukeX <> x And nukeY <> y) And (boxX <> x And boxY <> y) Then
						walls(x, y) = 1
						objWalls(x, y) = CreateCube()
						EntityTexture objWalls(x, y), texWall
						EntityType objWalls(x, y), typNibble
						ScaleEntity objWalls(x, y), 1, 1.5, 1
						PositionEntity objWalls(x, y), x * 2 - 26 , -1, y * 2 - 26
						ax = Rand(0, 1)
						ay = Rand(0, 3)
						RotateEntity objWalls(x, y), ax * 180, ay * 90, 0
						wallcount = wallcount + 1
						spawn = spawn + 1
						wallSpawn = True
					End If
				Wend 
			ElseIf power <= 110 Then
; 1ST PERSON VIEW
				If soundEnabled Then PlaySound sndRad
				score = score + 100	* difficulty
				newmessage = "Woah! View switch!"
				If FPSView Then
					FPSView = False
					PositionEntity objCamTarget, -10, 4.5, 0, False
				Else
					FPSView = True
					PositionEntity objCamTarget, 0.25, 0.75, 0, False
				End If
			End If
		End If
	End If

; GENERATE A NEW NUKE, IF NOT PRESENT
	If Not present Then
		present = True
		objNuke = LoadMesh("models\nuke.3ds")
		ScaleEntity objNuke, 0.005, 0.005, 0.005
		TurnEntity objNuke, 90, 0, 0
		EntityFX objNuke, 1
		lgtNuke = CreateLight(2, objNuke)
		LightColor lgtNuke, 5, 255, 0
		LightRange lgtNuke, 2
		EntityTexture objNuke, texNuke		
		x = 1
		y = 1
		While walls(x, y) Or (boxX = x And boxY = y)
			x = Rand(2, 24)
			y = Rand(2, 24)
		Wend
		nukeX = x
		nukeY = y
		PositionEntity objNuke, x * 2 - 26, 1.5, y * 2 - 26
		CreatePuff(objNuke, camDefault, texGreen, texYellow, texSpark)
	Else
		TurnEntity objNuke, 0, 0, 3
	End If
; IF NUKE IS WITHIN 1.5 RADIUS, GET IT
	dnx# = EntityX(objNibbler(0)) - EntityX(objNuke)
	dnz# = EntityZ(objNibbler(0)) - EntityZ(objNuke)
	dn# = Sqr(dnx# * dnx# + dnz# * dnz#)
	If dn# <= 1.5 Then
		If soundEnabled Then PlaySound sndRad
		CreatePuff(objNibbler(0), camDefault, texGreen, texYellow, texSpark)
		FreeEntity lgtNuke
		FreeEntity objNuke
		present = False
		collected = collected + 1
		score = score + level * collected * 100 * difficulty
		For count = length + 1 To length + 10 * collected
			px# = EntityX(objNibbler(count - 1))
			py# = EntityY(objNibbler(count - 1))
			pz# = EntityZ(objNibbler(count - 1))
			If sphereDetail > 1 Then
				objNibbler(count) = CreateSphere(sphereDetail)
			ElseIf sphereDetail = 1 Then
				objNibbler(count) = CreateCone(3)
			ElseIf sphereDetail = 0 Then
				objNibbler(count) = LoadSprite("images\nibbler.bmp", 4)
				SpriteViewMode objNibbler(count), 1
			End If
			If sphereDetail > 0 Then
				EntityTexture objNibbler(count), texNibble
			End If
			RotateEntity objNibbler(count), Rnd(0, 360), Rnd(0, 360), Rnd(0, 360)
			PositionEntity objNibbler(count), px#, py#, pz#
			EntityType objNibbler(count), typNibble
			EntityRadius objNibbler(count), 1
		Next
		length = length + 10 * collected
; ALL COLLECTED, NEW LEVEL, OR END GAME
		If collected = 10 Then
			level = level + 1
			collected = 0
			score = score + ((50 * wallcount) - (startinglives * 500)) * difficulty
			If level = 21 Then
				score = score + 1000 * lives * difficulty
				lives = lives + 1
				finished = True
			Else
				If soundEnabled Then PlaySound sndYeah
				Gosub Level
			End If
		End If
	End If
	
	fps = fps + 1
	If timer < MilliSecs() - 1000 Then
		lastfps = fps
		fps = 0
		timer = MilliSecs()
	End If
	
; RAISE WALLS IF NEED BE
	If wallSpawn Then
		all = True
		For x = 0 To 24
			For y = 0 To 24
				If walls(x, y) Then
					If EntityY(objWalls(x, y)) < 0 Then
						all = False
						PositionEntity objWalls(x, y), EntityX(objWalls(x, y)), EntityY(objWalls(x, y)) + 0.01, EntityZ(objWalls(x, y))
					End If
				End If
			Next
		Next
		If all Then
			wallSpawn = False
		End If
	End If

; PREVENT NIBBLE FROM FALLING DOWN
	If EntityY(objNibbler(0)) < 0 Then
		PositionEntity objNibbler(0), EntityX(objNibbler(0)), 0, EntityZ(objNibbler(0))
	End If
	
; REPOSITION EACH NIBBLER IN FUNCTION OF PREVIOUS ONE

	For count = length To 1 Step -1
		PositionEntity objNibbler(count), EntityX(objNibbler(count - 1)), EntityY(objNibbler(count - 1)), EntityZ(objNibbler(count - 1))
	Next
; HANDLE MOVEMENT FOR NIBBLER	
	MoveEntity objNibbler(0), speed#, 0, 0

; CHECK FOR LEFT/RIGHT, TURNS IT
	If KeyDown(keyLeft) Then
		TurnEntity objNibbler(0), 0, TurnAngle, 0
	End If
	If KeyDown(keyRight) Then
		TurnEntity objNibbler(0), 0, -1 * TurnAngle, 0
	End If
	key = GetKey()
; JUMP HEIGHT
	If jumping And JumpActivated < (MilliSecs() - 30000) And EntityY(objNibbler(0)) = 0
		If soundEnabled Then PlaySound sndJumpAct
		jumping = False
		newmessage = "Jump deactivated..."
		msgid = msgid + 1
	End If
	If KeyDown(keyJump) And jump = 0 And JumpActivated > (MilliSecs() - 30000)
		If soundEnabled Then PlaySound sndJump
		jump = 50
	End If
; TURN 90
	If turning And Turn90Activated < (MilliSecs() - 30000)
		If soundEnabled Then PlaySound(sndTurnAct)
		turning = False
		newmessage = "Sharp turns deactivated..."
		msgid = msgid + 1
	End If
	If KeyHit(keySharpRight) And Turn90Activated > (MilliSecs() - 30000) Then
		If soundEnabled Then PlaySound sndTurn
		TurnEntity objNibbler(0), 0, -89.999, 0
	End If
	If KeyHit(keySharpLeft) And Turn90Activated > (MilliSecs() - 30000) Then
		If soundEnabled Then PlaySound sndTurn
		TurnEntity objNibbler(0), 0, 89.999, 0
	End If
	FlushKeys
; CALCULATE JUMPS
	If jump > 0 Then
		px# = EntityX(objNibbler(0))
		py# = EntityY(objNibbler(0)) + 0.25 * (jump - 25) / 25
		pz# = EntityZ(objNibbler(0))
		PositionEntity objNibbler(0), px#, py#, pz#
		jump = jump - 1
	End If
	If jump = 0 And EntityY(objNibbler(0)) <> 0 Then
		px# = EntityX(objNibbler(0))
		py# = EntityY(objNibbler(0)) * 0.9
		pz# = EntityZ(objNibbler(0))
		PositionEntity objNibbler(0), px#, py#, pz#
	End If
	
	lx# = cx#
	lz# = cz#
	cx# = EntityX(objNibbler(0))
	cz# = EntityZ(objNibbler(0))
	dx# = cx# - lx#
	dz# = cz# - lz#
	d# = Sqr(dx# * dx# + dz# * dz#)
	If difficulty = 1 Then
		d# = d# + 0.05
	End If
	If d# < ld# Then
		ld# = d#
	End If
	
; CHECK COLLISIONS
	If EntityCollided(objNibbler(0), typNibble) Or EntityCollided(objNibbler(0), typWalls) Then
		If d# < 0.25 And d# > 0.15 Then
			If soundEnabled Then PlaySound sndCollision
		End If
		If d# < 0.15 Then
			c = True
		End If
	End If

	cf# = (0.25 - d#) / 0.001
	If cf# > coll# Then
		coll# = cf#
	Else
		coll# = coll# * 0.95
	End If
	
	If EntityX(objNibbler(0)) > 24.5 Or EntityX(objNibbler(0)) < -24.5 Then
		c = True
		coll# = 1
	End If
		
	If EntityZ(objNibbler(0)) > 24.5 Or EntityZ(objNibbler(0)) < -24.5 Then
		c = True
		coll# = 1
	End If
	
	CameraClsColor camDefault, 2.55 * coll#, 0, 0

; PARTICLES UPDATES
	If ParticlesEnabled Then
		PW_UpdateEmitters
		PW_UpdateParticles
	End If

; RENDER WORLD
	UpdateWorld
	RenderWorld

; DISPLAY TIMERS

	If jumping And JumpActivated > (MilliSecs() - 30000) Then
		DrawImage imgTimer, 50, 50
		timerText$ = Str(Int((JumpActivated - (MilliSecs() - 30000)) / 1000))
		timerText = Str(Int(timerText) + 1)
		If Len(timerText) = 1 Then 
			timerText = "0" + timerText
		End If
		DrawImage sprTimer, 64, 58, 0
		DrawImage sprTimer, 88, 58, Mid(timerText, 1, 1)
		DrawImage sprTimer, 113, 58, Mid(timerText, 2, 1)		
	End If
	If turning And Turn90Activated > (MilliSecs() - 30000) Then
		DrawImage imgTimer, 493, 50
		timerText$ = Str(Int((Turn90Activated - (MilliSecs() - 30000)) / 1000))
		timerText = Str(Int(timerText) + 1)
		If Len(timerText) = 1 Then 
			timerText = "0" + timerText
		End If
		DrawImage sprTimer, 507, 58, 0
		DrawImage sprTimer, 531, 58, Mid(timerText, 1, 1)
		DrawImage sprTimer, 556, 58, Mid(timerText, 2, 1)		
	End If
	
; CALCULATE ODOMETER COMPLEX/SIMPLE
	If complexscore Then
		If sco < score Then
			diffe = score - sco
			If diffe > 10000 Then
				sco = sco + 999
			ElseIf diffe > 1000 Then
				sco = sco + 99
			ElseIf diffe > 100
				sco = sco + 9
			Else
				sco = sco + 1
			End If
		End If	
	
		scor$ = Str(sco)
		While Len(scor) < 7
			scor = "0" + scor
		Wend
		For count = 1 To 7
			Select Int(Mid(scor, 8 - count, 1))
				Case "0"
					target(7 - count) = 205
				Case "1"
					target(7 - count) = 240
				Case "2"
					target(7 - count) = 280
				Case "3"
					target(7 - count) = 315
				Case "4"
					target(7 - count) = 350
				Case "5"
					target(7 - count) = 30
				Case "6"
					target(7 - count) = 65
				Case "7"
					target(7 - count) = 100
				Case "8"
					target(7 - count) = 140
				Case "9"
					target(7 - count) = 170
			End Select
		Next
	
		For count = 0 To 6
			If current(count) <> target(count) Then
				RotateEntity objOdo(count), current(count), 0, 90
				current(count) = current(count) + 5
				If current(count) = 360 Then
					current(count) = 0
				End If
			End If
		Next
	Else
		scor$ = Str(score)
		For count = 1 To Len(scor)
			DrawImage sprScore, 143 + (7 - count) * 27, 375, Mid(scor, Len(scor) - count + 1, 1)
		Next
		For count = count To 7
			DrawImage sprScore, 143 + (7 - count) * 27, 375, 0
		Next
	End If

; CALCULATE COMPLEX/SIMPLE LEVEL
	If complexlevel Then	
		snaketarget# = 5 - collected * 8.5 / 9
		If snakepos > snaketarget Then
			MoveEntity camNibbler, -0.05, 0, 0
			snakepos = snakepos - 0.05
		End If
	Else
		snaketarget# = collected * 255 / 9
		If snaketarget > snakecol Then
			snakecol = snakecol + 1
		Else
			snakecol = snaketarget
		End If
		CameraClsColor camNibbler, snakecol, snakecol, 0
	End If

; DRAW UI COMPONENTS	
	DrawImage imgLives, 470, 300
	
	If lives > 0
		DrawImage sprNumbers, 580, 317, lives
	Else
		DrawImage sprNumbers, 580, 317, 0
	End If
	If level < 10 Then
		DrawImage sprNumbers, 455, 378, level
	ElseIf level < 20 Then
		DrawImage sprNumbers, 455, 378, 1
		DrawImage sprNumbers, 475, 378, (level - 10)
	Else
		DrawImage sprNumbers, 455, 378, 2
		DrawImage sprNumbers, 475, 378, 0
	End If
	
; FPS DISPLAY
	If displayfps Then
		
		Color 85, 85, 85
		Text 31, 31, "FPS: " + lastfps
		If lastfps < frmRateLimit Then
			Color 255, 255 * lastfps / frmRateLimit, 255 * lastfps / frmRateLimit
		Else
			Color 255, 255, 255
		End If
		Text 30, 30, "FPS: " + lastfps
	End If
	
; TEMPORARY TEXT

;	Text 30, 30, TrisRendered()


; MOVE OLD MESSAGE AWAY AND NEW ONE IN
	If msgid <> oldmsgid Then
		DrawImage imgBlack, 0, 445
		If newmessagep < 420 Then
			newmessagep = newmessagep + msgtrans
			If newmessagep > 420 Then
				newmessagep = 420
			End If
		End If
		messagep = messagep - msgtrans
		Color 85, 85, 85
		Text messagep + 1, 459, message, True, True
		Text 741 - newmessagep, 459, newmessage, True, True
		Color 255, 255, 200
		Text messagep, 458, message, True, True
		Text 740 - newmessagep, 458, newmessage, True, True
		If newmessagep = 420 And (messagep < -200) Then
			message = newmessage
			newmessage = ""
			oldmsgid = msgid
			messagep = 320
			newmessagep = 0
		End If
	End If

	Flip

; PAUSE
	If key = 27
		Gosub RenderScreen
		DrawImage imgWindow, 125, 100
		
		ShowPointer
		
		Color 0, 0, 0
		Text 146, 106, "Game Paused"
		Color 0, 105, 0
		Text 145, 105, "Game Paused"
		
		Color 0, 0, 0
		Text 286, 171, "To resume the game, close this window.", True
		Select difficulty
			Case 1
				dif$ = "Easy"
			Case 2
				dif$ = "Medium"
			Case 3
				dif$ = "Hard"
			Case 4
				dif$ = "Insane!"
		End Select
		Text 286, 191, "Difficulty: " + dif + ", Collected: " + collected + "/10", True
		Color 0, 255, 0
		Text 285, 170, "To resume the game, close this window.", True
		Text 285, 190, "Difficulty: " + dif + ", Collected: " + collected + "/10", True
		
	DrawImage imgQuit, 325, 215

	exited = False
	FlushKeys
	FlushMouse
	
	While Not exited
	
		WaitTimer(frmRateTimer)

	; FADE OUT MUSIC
			If mVol > 0 And musicEnabled Then
				mVol = mVol - 0.05
				If mVol < 0 Then
					mVol = 0
				End If
				ChannelVolume chnMusic, mVol
			End If		
		
			key = GetKey()
			mb = GetMouse()
			If key = 27 Or key = 32 Or key = 13 Then
				If soundEnabled Then PlaySound sndClick
				exited = True
			End If
			If mb = 1 And MouseArea(419, 106, 16, 16)
				If soundEnabled Then PlaySound sndClick
				exited = True
			End If
			If mb = 1 And MouseArea(325, 215, 108, 36)
				If soundEnabled Then PlaySound sndDeath
				message = "You have abandonned the game!"
				c = True
				abandon = True
				lives = 0
				exited = True
			End If
	
			If msgid <> oldmsgid Then
				DrawImage imgBlack, 0, 445
				If newmessagep < 420 Then
					newmessagep = newmessagep + msgtrans
					If newmessagep > 420 Then
						newmessagep = 420
					End If
				End If
				messagep = messagep - msgtrans
				Color 85, 85, 85
				Text messagep + 1, 459, message, True, True
				Text 741 - newmessagep, 459, newmessage, True, True
				Color 255, 255, 200
				Text messagep, 458, message, True, True
				Text 740 - newmessagep, 458, newmessage, True, True
				If newmessagep = 420 And (messagep < -200) Then
					message = newmessage
					newmessage = ""
					oldmsgid = msgid
					messagep = 320
					newmessagep = 0
				End If
			End If
		
		Wend
		FlushKeys
		If soundEnabled Then PlaySound sndClick

		HidePointer
	End If
	
Wend

For i = 0 To 12
	PW_KillParticles(emtPuff(i))
	PW_KillEmitter(emtPuff(i))
Next
Puffs = 0

Include "ending.bb"

Function MouseArea(x, y, width, height)
	If MouseX() >= x And MouseX() <= x + width
		If MouseY() >= y And MouseY() <= y + height
			Return True
		Else
			Return False
		End If
	Else
		Return False
	End If

End Function

Function CreatePuff(objOrigin, cam, tex1, tex2, tex3)
	tex(0) = tex1
	tex(1) = tex2
	tex(2) = tex3
	If Puffs = 12 Then
		Puffs = 0
	End If
	For i = Puffs To Puffs + 2
		emtPuff(i) = PW_CreateEmitter()
		TurnEntity emtPuff(i), -90, 0, 0
		PW_SetEmitter(emtPuff(i), 30, 25, 5, 10, 45, 45)
		PW_SetParticle(emtPuff(i), objTri, 0, 0, cam, 0)
		PW_SetTexture(emtPuff(i), tex(i - Puffs), 0, 0, 0)
		PW_SetVelocity(emtPuff(i), 0.5, 0.1, 0.999, -0.03)
		PW_SetAlpha(emtPuff(i), 0.8, 0.1, 15)
		PW_SetScale(emtPuff(i), 0.12, 0.12, 0.12, 0, 1)
		PositionEntity emtPuff(i), EntityX(objOrigin), EntityY(objOrigin), EntityZ(objOrigin)
	Next
	Puffs = Puffs + 3
End Function

.RenderScreen
	DrawImage imgUI, 0, 0
	
	If complexscore Then
		sco = score
		scor$ = Str(sco)
		For count = 1 To Len(scor)
			Select Int(Mid(scor, Len(scor) - count + 1, 1))
				Case "0"
					target(7 - count) = 205
				Case "1"
					target(7 - count) = 240
				Case "2"
					target(7 - count) = 280
				Case "3"
					target(7 - count) = 315
				Case "4"
					target(7 - count) = 350
				Case "5"
					target(7 - count) = 30
				Case "6"
					target(7 - count) = 65
				Case "7"
					target(7 - count) = 100
				Case "8"
					target(7 - count) = 140
				Case "9"
					target(7 - count) = 170
			End Select
		Next
		For count = 0 To 6
			current(count) = target(count)
			RotateEntity objOdo(count), current(count), 0, 90
		Next
	Else
		scor$ = Str(score)
		For count = 1 To Len(scor)
			DrawImage sprScore, 143 + (7 - count) * 27, 375, Mid(scor, Len(scor) - count + 1, 1)
		Next
		For count = count To 7
			DrawImage sprScore, 143 + (7 - count) * 27, 375, 0
		Next
	End If

	UpdateWorld
	RenderWorld

	DrawImage imgLives, 470, 300
	
	If lives > 0
		DrawImage sprNumbers, 580, 317, lives
	Else
		DrawImage sprNumbers, 580, 317, 0
	End If
	If level < 10 Then
		DrawImage sprNumbers, 455, 378, level
	ElseIf level < 20
		DrawImage sprNumbers, 455, 378, 1
		DrawImage sprNumbers, 475, 378, (level - 10)
	Else
		DrawImage sprNumbers, 455, 378, 2
		DrawImage sprNumbers, 475, 378, 0
	End If

	DrawImage imgBlack, 0, 445
	Color 85, 85, 85
	Text messagep + 1, 459, message, True, True
	Text 741 - newmessagep, 459, newmessage, True, True
	Color 255, 255, 200
	Text messagep, 458, message, True, True
	Text 740 - newmessagep, 458, newmessage, True, True

	Flip

Return 

.CloseWindow
	exited = False
	FlushKeys
	FlushMouse
	While Not exited
	
		WaitTimer(frmRateTimer)

; FADE OUT MUSIC
		If mVol > 0 And musicEnabled Then
			mVol = mVol - 0.05
			If mVol < 0 Then
				mVol = 0
			End If
			ChannelVolume chnMusic, mVol
		End If		
		
		key = GetKey()
		mb = GetMouse()
		If key = 27 Or key = 32 Or key = 13 Then
			exited = True
		End If
		If mb = 1 And MouseArea(419, 106, 16, 16)
			exited = True
		End If

		If msgid <> oldmsgid Then
			DrawImage imgBlack, 0, 445
			If newmessagep < 420 Then
				newmessagep = newmessagep + msgtrans
				If newmessagep > 420 Then
					newmessagep = 420
				End If
			End If
			messagep = messagep - msgtrans
			Color 85, 85, 85
			Text messagep + 1, 459, message, True, True
			Text 741 - newmessagep, 459, newmessage, True, True
			Color 255, 255, 200
			Text messagep, 458, message, True, True
			Text 740 - newmessagep, 458, newmessage, True, True
			If newmessagep = 420 And (messagep < -200) Then
				message = newmessage
				newmessage = ""
				oldmsgid = msgid
				messagep = 320
				newmessagep = 0
			End If
		End If
	
	Wend
	FlushKeys
	If soundEnabled Then PlaySound sndClick
	Delay 100
	
Return